Zmax <-
  function(data,method="rmbs")
  {
    rf <- data[1,1:3]
    sf <- data[2,1:3]
    rm <- data[1,4:5]
    sm <- data[2,4:5]

    nf0 <- rf[1] + sf[1]
    nf1 <- rf[2] + sf[2]
    nf2 <- rf[3] + sf[3]
    nm0 <- rm[1] + sm[1]
    nm1 <- rm[2] + sm[2]
    nrm <- sum(rm)
    nsm <- sum(sm)
    nrf <- sum(rf)
    nsf <- sum(sf)
    nf <- sum(rf+sf)
    nm <- sum(rm+sm)

    p_m <- rm[2]/nrm
    q_m <- sm[2]/nsm
    p_f <- (2*rf[3] + rf[2]) / (2*nrf)
    q_f <- (2*sf[3] + sf[2]) / (2*nsf)

    pf2<-nf2/nf
    pf<-(nf1+2*nf2)/(2*nf)
    F<-(pf2-pf^2)/(pf*(1-pf))
    var_m<-nm1*nm0/(nrm*nsm*nm)
    var_f<-(nf*(nf1/4+nf2)-(nf1/2+nf2)^2)/(nrf*nsf*nf)

    n_fe <- nf/(1 + F)

    w1 <- 2*n_fe/(nm + 2*n_fe)
    T1 <- w1*(q_f-p_f) + (1-w1)*(q_m-p_m)
    var_T1 <- w1^2 * var_f + (1-w1)^2 * var_m
    Z1 <- T1/sqrt(var_T1)

    w2 <- n_fe/(nm + n_fe)
    T2 <- w2*(q_f-p_f) + (1-w2)*(q_m-p_m)
    var_T2 <- w2^2*var_f + (1-w2)^2*var_m
    Z2 <- T2/sqrt(var_T2)

    Zmax <- pmax(abs(Z1),abs(Z2))

    rho <- (w1*w2*var_f + (1-w1)*(1-w2)*var_m) / sqrt(var_T1*var_T2)

    if (method=="rmbs"){
      L <- acos(rho)
      L_tmp <- pnorm(L*Zmax/2)+pnorm((pi-L)*Zmax/2)
      pvalue <- 4 * dnorm(Zmax) * Zmax^(-1) * (L_tmp-1)
    }

    if (method=="norm"){
      u<-c(0,0)
      sigma <- matrix(c(1,rho,rho,1),nrow=2)
      p_1 <- pmvnorm(lower=c(Zmax,Zmax),upper=c(Inf,Inf),mean=u,sigma=sigma,abseps=1e-20)
      p_2 <- pmvnorm(lower=c(Zmax,-Zmax),upper=c(Inf,Inf),mean=u,sigma=sigma,abseps=1e-20)
      pvalue <- 2 * (pnorm(-Zmax) + p_2 - p_1)
    }

    output <- matrix(nrow=1,ncol=3)
    colnames(output)<-c("statistic","p.value","method")

    output[1,1]<-round(Zmax,3)
    output[1,2]<-pvalue
    output[1,3]<-method

    list(output)

  }
